//
//  HWFileAnalyzer.h
//  AFHandbrakeWrapper
//
//  Created by Scott on 7/3/09.
//  Copyright 2009 The Little App Factory. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "HWFileInformation.h"


@interface HWFileAnalyzer : NSObject {
	
	id						__strong delegate;
	NSURL*					handbrakeURL;
	NSTask*					task;
	NSFileHandle*			taskOutput;
	NSURL*					fileURL;
	HWFileInformation*		fileInformation;
}

@property (strong) id					delegate;
@property (strong) NSURL*				handbrakeURL;
@property (strong) NSTask*				task;
@property (strong) NSFileHandle*		taskOutput;
@property (strong) NSURL*				fileURL;
@property (strong) HWFileInformation*	fileInformation;

- (void)setDelegate:(id)_delegate;
- (id)initWithHandbrakeURL:(NSURL *)_handbrakeURL;
- (HWFileInformation*)analyzeURLAndWait:(NSURL *)_fileURL;
- (void)analyzeURL:(NSURL *)_fileURL waitUntilDone:(BOOL)_wait;

@end
