//
//  HWFileInformation.h
//  AFHandbrakeWrapper
//
//  Created by Scott on 7/3/09.
//  Copyright 2009 The Little App Factory. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "HWFileAudioStream.h"
#import "HWFileVideoStream.h"


@interface HWFileInformation : NSObject {

	NSString*			rawOutput;
	NSString*			filename;
	NSString*			container;
	NSString*			duration;
	NSString*			start;
	NSString*			videoBitrate;
	int					selectedAudioStreamIndex;
	int					selectedVideoStreamIndex;
	NSMutableArray*		audioStreamArray;
	NSMutableArray*		videoStreamArray;
}

@property (strong) NSString*		rawOutput;
@property (strong) NSString*		filename;
@property (strong) NSString*		container;
@property (strong) NSString*		duration;
@property (strong) NSString*		start;
@property (strong) NSString*		videoBitrate;
@property (assign) int				selectedAudioStreamIndex;
@property (assign) int				selectedVideoStreamIndex;
@property (strong) NSMutableArray*	audioStreamArray;
@property (strong) NSMutableArray*	videoStreamArray;

- (id)initWithFilename:(NSString *)filename rawOutput:(NSString *)rawOutput;
- (void)dump;
- (HWFileAudioStream *)selectedAudioStream;
- (HWFileVideoStream *)selectedVideoStream;

@end
