//
//  HWFileTranscoder.h
//  AFHandbrakeWrapper
//
//  Created by Scott on 3/28/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface HWFileTranscoder : NSObject {
	
	// private data members
	id							 delegate;
	long						 duration;
	NSString					*applicationUrl;
	NSMutableArray				*applicationSettings;
	NSTask						*task;
	int							 priority;
	NSPipe						*inputPipe;
	NSPipe						*outputPipe;
	NSFileHandle				*taskInput;
	NSFileHandle				*taskOutput;
	NSString					*outputBuffer;
	NSTimer						*monitorTimer;
	int							 linesSinceLastMonitor;
	NSString					*lastLine;	
	BOOL						 isInputStream;
	int							 restartCount;
	BOOL						 isSuspended;
	
	NSString					*inputDimensions;
	NSString					*inputFrameRate;
	NSDate						*startDate;
	NSTimeInterval				 lastUpdateInterval;
	
}

// accessor members
- (id)delegate;
- (void)setDelegate:(id)value;

// public method members
- (id)initWithHandbrakeURL:(NSURL *)handbrakeURL settings:(NSMutableArray *)settings;
- (void)start;
- (void)stop;
- (void)suspend;
- (void)resume;
- (BOOL)isSuspended;
- (void)taskCompleted:(NSNotification *)notif;
- (void)processTaskOutput:(NSString *)output;
- (void)taskDataAvailable:(NSNotification *)notif;
- (NSString *)actionText;

// private method members
- (void)handleEncodingLine:(NSString *)line;

@end
