//
//  HWHelper.h
//  AFHandbrakeWrapper
//
//  Created by Scott on 7/4/09.
//  Copyright 2009 The Little App Factory. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "HWFileAnalyzer.h"
#import "HWFileTranscoder.h"


@interface HWHelper : NSObject <NSURLDownloadDelegate> {
	
	id						 delegate;
	NSURL					*handbrakeURL;
	HWFileTranscoder		*transcoder;
	BOOL					 isStopping;
	NSString				*handbrakePath;
	NSURLDownload			*handbrakeDownload;
	NSURLResponse			*handbrakeResponse;
	long long				 handbrakeBytesReceived;
	NSTask					*handbrakeUnzipTask;	
}

- (BOOL)handbrakeExistsAtPath:(NSString*)path withExpectedHash:(NSString*)expectedHash;
- (void)handbrakeDownloadURL:(NSURL *)url toPath:(NSString *)path withExpectedHash:(NSString *)expectedHash;
+ (BOOL)isVideoFileURL:(NSURL *)fileURL;
+ (int)cpuCount;
+ (NSString*)handbrakeFilename;

- (id)initWithHandbrakeURL:(NSURL *)handbrakeURL;
- (id)delegate;
- (void)setDelegate:(id)delegate;
- (HWFileInformation*)analyzeURLAndWait:(NSURL *)_fileURL;
- (void)transcodeFolderURL:(NSURL *)_inputFolderURL toFileURL:(NSURL *)_outputFileURL fromTitle:(int)titleIndex parameters:(NSString*)_parameters audioStream:(NSString*)_audioStream subtitleLanguage:(NSString*)_subtitleLanguage alwaysIncludeSubtitle:(BOOL)_always;
- (void)transcodeFolderURL:(NSURL *)_inputFolderURL toFileURL:(NSURL *)_outputFileURL fromTitle:(int)titleIndex presetName:(NSString*)_presetName audioStream:(NSString*)_audioStream subtitleLanguage:(NSString*)_subtitleLanguage alwaysIncludeSubtitle:(BOOL)_always;
- (void)transcodeFolderURL:(NSURL *)_inputFolderURL toFileURL:(NSURL *)_outputFileURL fromTitle:(int)titleIndex parameters:(NSString*)_parameters audioStream:(NSString*)_audioStream;
- (void)transcodeFolderURL:(NSURL *)_inputFolderURL toFileURL:(NSURL *)_outputFileURL fromTitle:(int)titleIndex presetName:(NSString*)_presetName audioStream:(NSString*)_audioStream;
- (void)transcodeFileURL:(NSURL *)_inputFileURL toFileURL:(NSURL *)_outputFileURL presetName:(NSString*)_presetName audioStream:(NSString*)_audioStream;
- (NSURL*)handbrakeURL;
- (void)stop;

@end
