//
//  AFFeedbackWindowController.h
//  AFRegistration
//
//  Created by Duncan Campbell on 12/01/10.
//  Copyright 2010 The Little App Factory Pty, Ltd. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface AFFeedbackWindowController : NSWindowController {

	IBOutlet NSTextField *emailTo;
	IBOutlet NSTextField *emailFrom;
	IBOutlet NSTextField *emailSubject;
	
	IBOutlet NSButton *attachSystemInfo;
	IBOutlet NSButton *attachApplicationLog;
	IBOutlet NSButton *attachPreferences;
	
	IBOutlet NSTextView *message;
	
	IBOutlet NSProgressIndicator *progress;
	
	NSString *applicationName;
	NSString *toEmail;
	NSString *feedbackSubject;
	NSString *feedbackUrl;
	NSString *logFilePath;
	
	id delegate;
	NSMutableData *receivedData;
	
	//progress sheets
	IBOutlet NSTextField *sheetFailEmailTo;
	IBOutlet NSWindow *sheetProgress;
	IBOutlet NSWindow *sheetSuccess;
	IBOutlet NSWindow *sheetFailure;
}

@property (retain) NSString *applicationName;
@property (retain) NSString *toEmail;
@property (retain) NSString *feedbackSubject;
@property (retain) NSString *feedbackUrl;
@property (retain) NSString *logFilePath;

@property (retain) id delegate;

- (IBAction)successClicked:(id)sender;
- (IBAction)failClicked:(id)sender;
- (IBAction)cancelClicked:(id)sender;
- (IBAction)sendClicked:(id)sender;

@end
