//
//  DiscManager.h
//  AFRipEngine
//
//  Created by Scott on 3/1/11.
//  Copyright 2011 . All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface DVDManager : NSObject {

	
	id								delegate;
	NSURLDownload*					download;
	NSURLResponse*					response;
	NSString*						downloadToPath;
	NSUInteger						byteCount;
	NSBundle*						encryptionBundle;
	
}


@property (assign) id				delegate;
@property (retain) NSURLDownload*	download;
@property (retain) NSURLResponse*	response;
@property (retain) NSString*		downloadToPath;
@property (assign) NSUInteger		byteCount;
@property (retain) NSBundle*		encryptionBundle;


+(DVDManager*)sharedManager;

-(BOOL)isURLUDF:(NSURL*)_url;
-(BOOL)isURLProtected:(NSURL*)_url;
-(id)readerWithBSDName:_deviceName forUDF:(BOOL)_isUDF;
-(id)readerWithBSDName:_deviceName mountPoint:(NSString *)mountPoint forUDF:(BOOL)_isUDF;
-(void)loadEncryptionBundleURL:(NSURL*)_url;
-(BOOL)encryptionBundleExists:(NSString*)filename withExpectedHash:(NSString*)expectedHash;
-(BOOL)encryptionBundleExistsAtPath:(NSString*)path withExpectedHash:(NSString*)expectedHash;
-(void)downloadEncryptionBundleURL:(NSURL*)_url toPath:(NSString *)path withExpectedHash:(NSString *)expectedHash;
-(void)removeEncryptionBundleFromPath:(NSString*)_path;
-(BOOL)encryptionBundleExistsAtPath:(NSString*)_path;

@end
