//
//  HFSFileHandle.h
//  UDFKit
//
//  Created by Scott on 8/11/09.
//  Copyright 2009 The Little App Factory. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "UDFKit.h"
#import "DVDFileHandle.h"


@interface HFSFileHandle : NSObject {
	
	NSFileHandle	*fileHandle;

	// dvd file handle
	NSString		*path;
    NSData			*titleKey;
	
}

// dvd file handle
@property (readonly) NSData*			titleKey;
@property (readonly) NSString*			path;
@property (readonly) uint64_t			size;

// dvd file handle
- (id)initWithReader:(id)_reader path:(NSString*)_path;
- (NSData*)readDataOfLength:(uint32_t)length;
- (NSData*)readDataToEndOfFile;
- (void)seekToFileOffset:(unsigned long long)offset;
- (uint64_t)offsetInFile;


@end
