//
//  HFSReader.h
//  UDFKit
//
//  Created by Scott on 8/11/09.
//  Copyright 2009 The Little App Factory. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "HFSFileHandle.h"
#import "DVDReader.h"


@interface HFSReader : NSObject {

	NSString			*rootPath;
    NSString            *mountPoint;
    BOOL				 closed;

    NSString			*pathToDevice;
    int					 fileDescriptor;
    int					 numberOfLayers;
    BOOL				 isProtected;
    int					 regionMask;
    NSOperationQueue	*lockPicks;
    NSData				*encryptedDiscKey;
    NSData				*discKey;
    struct {
        uint16_t		 flags;
        NSString		*descriptor;
        off_t			 offset;
        uint32_t		 length;
    } volume;
    NSMutableDictionary	*cache;
    NSMutableDictionary	*titleKeysByPath;
	
	// dvd reader
    off_t				 rawBlockCount;
	
}

@property (readonly) NSString* volumeDescription;
@property (readonly) NSData* discKey;
@property (readonly) int numberOfLayers;
@property (readonly) BOOL closed;

// dvd reader
@property (assign) off_t rawBlockCount;

- (id) initWithBSDName:(NSString*)_bsdName mountPoint:(NSString *)_mountPoint;

// dvd reader
-(void)close;
-(BOOL)fileExistsAtPath:(NSString*)path;
-(BOOL)fileExistsAtPath:(NSString*)path isDirectory:(BOOL*)isDirectory;
-(NSArray*)directoryContentsAtPath:(NSString*)path;
-(DVDFileHandle*)fileHandleForReadingAtPath:(NSString*)path;

@end
