//
//  RIDiscPatch.h
//  AFRipEngine
//
//  Created by Scott on 1/7/10.
//  Copyright 2010 The Little App Factory Pty, Ltd. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "RIStateFilter.h"


@interface RIDiscPatch : NSObject {

	NSString*			discIdent;
	NSMutableArray*		stateFilterArray;
	NSMutableArray*		branchFilterArray;
	NSMutableArray*		regionFilterArray;
	NSMutableArray*		titleFilterArray;
	RIMenuParameters	menuParameters;
	BOOL				branchLanguage;
	BOOL				branchRegion;
	BOOL				branchDisplayFormat;
	NSString			*mainTitle;

}


@property (retain) NSString*			discIdent;
@property (assign) RIMenuParameters		menuParameters;
@property (retain) NSMutableArray*		regionFilterArray;
@property (retain) NSMutableArray*		titleFilterArray;
@property (assign) BOOL					branchLanguage;
@property (assign) BOOL					branchRegion;
@property (assign) BOOL					branchDisplayFormat;
@property (retain) NSString*			mainTitle;

+(id)patchFromURL:(NSURL*)_url;

-(void)clear;
-(void)saveXMLToURL:(NSURL*)_url;
-(void)loadXMLFromXMLDocument:(NSXMLDocument*)_document;
-(void)loadXMLFromURL:(NSURL*)_url;
-(void)loadXMLFromString:(NSString*)_xml;
-(void)addStateFilter:(RIStateFilter*)_filter;
-(void)addBranchFilter:(RIBranch)_branch;
-(void)addBranchStringFilter:(NSString*)_branch;
-(BOOL)shouldExecuteVirtualMachine:(DKVirtualMachine*)_virtualMachine withCommand:(DKCommand*)_command;

@end
