#import "RIRipMode.h"
#import "RIReadErrorAction.h"
#import "DKDVDStructure.h"
#import "DKDVDStructureTitle.h"
#import "RIDiscPatch.h"
//#import "RIDiscPatchBuilder.h"


@class DVDReader;

@interface RIRipEngine : NSOperation {
    
	DVDReader*				reader;
	id						delegate;
	
	RIRipMode				ripMode;
	RIReadErrorAction		lastReadErrorAction;
	DKDVDStructure*			dvdStructure; 
	unsigned long long		totalBranchesExecuted;
	
	BOOL					filterOptimizeSkipLongMenus;
	BOOL					filterOptimizeSkipBranchLanguage;
	BOOL					filterOptimizeSkipBranchDisplayFormat;
	
	NSArray*				filterTitles;
	uint32_t				filterSecondsInToTitleMenu;
	
	RIDiscPatch*			discPatch;
	//RIDiscPatchBuilder	*discPatchBuilder;
}

- (id) initWithDVDReader:(DVDReader*)reader;

@property (assign, nonatomic) id	delegate; // NOT RETAINED
@property (readonly, nonatomic)		DVDReader* reader;
@property (assign, readonly)		DKDVDStructure *dvdStructure;
@property (assign) RIRipMode		ripMode;
@property (assign) BOOL				filterOptimizeSkipLongMenus;
@property (assign) BOOL				filterOptimizeSkipBranchLanguage;
@property (assign) BOOL				filterOptimizeSkipBranchDisplayFormat;
@property (retain) NSArray*			filterTitles;
@property (retain) RIDiscPatch*		discPatch;
//@property (retain) RIDiscPatchBuilder *discPatchBuilder;


@end

@interface NSObject (RIRipEngineDelegate)
- (void) ripEngine:(RIRipEngine*)ripper queueSizeChanged:(unsigned int)size;
- (void) ripEngine:(RIRipEngine*)ripper didOpenFile:(NSString*)file ofLength:(uint64_t)length;
- (void) ripEngine:(RIRipEngine*)ripper didReadBlock:(NSData*)block fromOffset:(uint64_t)offset ofFile:(NSString*)file;
- (void) ripEngine:(RIRipEngine*)ripper didReadBlock:(NSData*)block fromOffset:(uint64_t)offset forTitle:(int)titleIndex;
- (void) ripEngine:(RIRipEngine*)ripper didAnalyzeSectors:(uint32_t)sectorCount;
- (void) ripEngine:(RIRipEngine*)ripper didFailWithException:(id)exception;
- (void) ripEngine:(RIRipEngine*)ripper didFindTitle:(int)titleIndex;
- (void) ripEngineDidComplete:(RIRipEngine*)ripper usingPlanOfAttack:(NSDictionary*)planOfAttack;
- (void) ripEngineHadReadError:(RIRipEngine*)ripper takeAction:(RIReadErrorAction*)action;
@end

extern NSString* const RIRipEngineGeneralException;
extern NSString* const RIRipEngineReadErrorException;
