#import <Cocoa/Cocoa.h>
#import "RIRipEngine.h"
#import "DKDVDStructure.h"
#import "RIReadErrorAction.h"
#import "DVDReader.h"


@class RITitleSetExtraInformation;

@interface RIRipEngineV2 : RIRipEngine 
{	
	BOOL						 started;
	NSMutableArray				*infoCache;
	NSMutableDictionary			*handlesForReading;
    uint32_t					 totalLengthsInSectorsByTitle[100];
	uint32_t					 lengthsInSectorsByTitle[100][10];
	CFMutableBitVectorRef		 copiedSectorsByTitle[100][10];

    int							 titleSetMax;
    int							 titleSetCount;
    uint8_t						 titleSetRemapTable[100];
	BOOL						 titlesExecutedTable[100];
	
	uint8_t						 titleIndex;
	BOOL						 titleInFilter;
	DKDVDStructureTitle			*titleInFilterObject;
	BOOL						 titlesInFilterCompleted;

#ifdef ENABLE_FORCE_ACTIVATED_BUTTON_REEXECUTE
	uint8_t						 forcedButtonVTS;
	uint32_t					 forcedButtonSector;
#endif
}


- (id) initWithDVDReader:(DVDReader*)reader;

@end
