//
//  RIStateFilter.h
//  AFRipEngine
//
//  Created by Scott on 1/9/10.
//  Copyright 2010 The Little App Factory Pty, Ltd. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DVDKit.h"
#import "DKVirtualMachine.h"
#import "DKCommand.h"


@interface RIStateFilter : NSObject {

	// parameters/register values
	BOOL		useSystemRegisters[24];
    uint16_t	systemRegisters[24];
	BOOL		useGeneralRegisters[16];
    uint16_t	generalRegisters[16];	
	
	// command values
	BOOL		useCommandBits;
	uint64_t	commandBits;
	BOOL		useCommandRow;
	int			commandRow;
	
}


@property (readonly) BOOL *useSystemRegisters;
@property (readonly) uint16_t *systemRegisters;
@property (readonly) BOOL *useGeneralRegisters;
@property (readonly) uint16_t *generalRegisters;
@property (assign) BOOL useCommandBits;
@property (assign) uint64_t commandBits;
@property (assign) BOOL useCommandRow;
@property (assign) int commandRow;


+(id)stateFilterFromXML:(NSXMLNode*)_node;
+(id)stateFilterFromVirtualMachine:(DKVirtualMachine*)_virtualMachine withCommand:(DKCommand*)_command;
+(id)stateFilterFromVirtualMachine:(DKVirtualMachine*)_virtualMachine;

-(void)clear;
-(NSXMLNode*)saveXMLToNode;
-(void)loadXMLFromNode:(NSXMLNode*)_node;


@end
